
HSC_SOURCES = $(filter %.hsc, $(HS_SOURCES))

HSC_HS_FILES = $(subst .hsc,.hs, $(HSC_SOURCES))
#HSC_C_FILES = $(subst .hsc,_hsc.c, $(HSC_SOURCES))
HSC_C_INCLUDES = $(subst .c,.h, $(HSC_C_FILES))

HS_OBJS = $(subst .hs,.o, $(subst .hsc,.o, $(HS_SOURCES)))
HI_FILES = $(subst .hs,.hi, $(subst .hsc,.hi, $(HS_SOURCES)))

C_OBJS = $(subst .c,.o, $(C_SOURCES) $(HSC_C_FILES))
HSC_C_OBJS = $(subst .c,.o, $(HSC_C_FILES))

OBJS = $(C_OBJS) $(HSC_C_OBJS) $(HS_OBJS)
TO_CLEAN += $(OBJS) $(TARGET) $(HSC_HS_FILES) $(HSC_C_FILES) \
	 $(HSC_C_INCLUDES) $(HI_FILES) $(TARGET_A)

.PHONY: subdirs subdirs-clean

all: subdirs $(TARGET) $(TARGET_A)

ifdef TARGET_A

$(TARGET_A): $(OBJS)
	$(AR) $(ARFLAGS) $@ $+

endif

%.o: %.hs
	$(GHC) $(GHC_COMPILE_FLAGS) -c $< -o $@

%.o: %.c
	$(GHC) $(GHC_C_COMPILE_FLAGS) -c $< -o $@

%.hs: %.hsc
	$(HSC2HS) $< -o $@

%.hi: %.o
	@:

%_hsc.c: %.hs
	@:

%_hsc.h: %.hs
	@:

clean: subdirs-clean
	$(RM) $(TO_CLEAN)

ifdef SUBDIRS

subdirs:
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i; done
	
subdirs-clean:
	set -e; for i in $(SUBDIRS); do $(MAKE) -C $$i clean; done

endif

